require 'uu/os/gvc/component'

module UU
  module OS
    module Form

      # Common input component.
      class Input < UU::OS::GVC::Component

        # Input width.
        attr_reader :width

        # Input value.
        attr_accessor :value

        # Input data binding.
        attr_accessor :data

        # Flag if component is read only.
        attr_accessor :read_only

        # Flag if component input is required.
        attr_accessor :required

        # Flag if component is disabled.
        attr_accessor :disabled

        # Flag whether to send value_change events for this component.
        attr_accessor :submit_value_change
        
        # Uri triggered instead of valueChange action when component changes value. value_change_action_uri is triggerd only if submit_value_change is enabled.
        attr_accessor :value_change_action_uri

        def value
          attributes[:value]
        end

        def value=(value)
          attributes[:value] = value
        end

        def data
          attributes[:data]
        end

        def data=(data)
          attributes[:data] = data
        end

        def read_only
          attributes[:readOnly]
        end

        def read_only=(read_only)
          attributes[:readOnly] = read_only
        end

        def required
          attributes[:required]
        end

        def required=(required)
          attributes[:required] = required
        end

        def disabled
          attributes[:disabled]
        end

        def disabled=(disabled)
          attributes[:disabled] = disabled
        end

        def submit_value_change
          attributes[:submitValueChange]
        end

        def submit_value_change=(value)
          attributes[:submitValueChange] = value
        end
        
        def value_change_action_uri
          attributes[:valueChangeActionUri]
        end

        def value_change_action_uri=(value)
          attributes[:valueChangeActionUri] = value
        end
        
      end
    end
  end
end
